// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/widgets.dart';
import 'package:wyatt_component_copy_with_extension/wyatt_component_copy_with_extension.dart';
import 'package:wyatt_ui_components/wyatt_ui_components.dart';

part 'flat_button_component.g.dart';

@ComponentProxyExtension()
abstract class FlatButtonComponent extends ButtonComponent
    with CopyWithMixin<$FlatButtonComponentCWProxy> {
  const FlatButtonComponent({
    this.mainAxisSize,
    this.prefix,
    this.suffix,
    this.label,
    super.disabledStyle,
    super.normalStyle,
    super.hoveredStyle,
    super.focusedStyle,
    super.tappedStyle,
    super.onPressed,
    super.disabled,
    super.themeResolver,
    super.key,
  });

  @override
  FlatButtonStyle? get disabledStyle;

  @override
  FlatButtonStyle? get normalStyle;

  @override
  FlatButtonStyle? get hoveredStyle;

  @override
  FlatButtonStyle? get focusedStyle;

  @override
  FlatButtonStyle? get tappedStyle;

  /// The main axis size of the button.
  final MainAxisSize? mainAxisSize;

  /// The prefix widget of the button.
  final Widget? prefix;

  /// The suffix widget of the button.
  final Widget? suffix;

  /// The label widget of the button.
  final TextWrapper? label;
}
